<template>
  <div>
    <div
      id="modal_producto_editar"
      class="modal fade"
      tabindex="-1"
      aria-hidden="true"
      data-bs-backdrop="static"
      data-bs-keyboard="false"
    >
      <div class="modal-dialog mw-750px">
        <div
          id="modal_producto_editar_formulario"
          class="modal-content rounded"
        >
          <div class="modal-header">
            <h3 class="modal-title">
              Editar un producto
            </h3>

            <div
              id="modal_producto_editar_btn_cerrar"
              class="btn btn-icon btn-sm btn-active-light-primary ms-2"
              data-bs-dismiss="modal"
              aria-label="Close"
              @click="onCerrarModal()"
            >
              <i class="bi bi-x-lg" />
            </div>
          </div>

          <div class="modal-body scroll-y px-10 px-lg-15 pt-0 pb-0">
            <div class="row">
              <div class="col-xxl-12 col-form-label">
                <label class="required fw-bolder fs-6">Nombre</label>
              </div>
              <div class="col-xxl-12">
                <input
                  v-model="mFormulario.nombre"
                  type="text"
                  class="form-control"
                  placeholder=""
                  maxlength="50"
                >
              </div>
            </div>

            <div class="row">
              <div class="col-xl-6">
                <div class="row">
                  <div class="col-xxl-12 col-form-label">
                    <label class="required fw-bolder fs-6">Tipo de unidad</label>
                  </div>
                  <div class="col-xxl-12">
                    <input
                      v-model="mFormulario.tipoUnidad"
                      type="text"
                      class="form-control"
                      placeholder=""
                      maxlength="20"
                    >
                  </div>
                </div>
              </div>
              <div class="col-xl-6">
                <div class="row">
                  <div class="col-xxl-12 col-form-label">
                    <label class="required fw-bolder fs-6">Precio</label>
                  </div>
                  <div class="col-12 input-group">
                    <input
                      v-model="mFormulario.precio"
                      type="number"
                      step="0.10"
                      class="form-control"
                    >
                    <select
                      v-model="mFormulario.tipoMoneda"
                      class="form-select"
                    >
                      <option
                        selected
                        value="BOB"
                      >
                        BOB
                      </option>
                      <option value="USD">
                        USD
                      </option>
                    </select>
                  </div>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-xl-6">
                <div class="row">
                  <div class="col-xxl-12 col-form-label">
                    <label class="required fw-bolder fs-6">Descuento gratuito</label>
                  </div>
                  <div class="col-xxl-12">
                    <input
                      v-model="mFormulario.descuentoGratuito"
                      type="number"
                      step="1"
                      min="0"
                      max="100"
                      class="form-control"
                      placeholder=""
                    >
                  </div>
                </div>
              </div>
              <div class="col-xl-6">
                <div class="row">
                  <div class="col-xxl-12 col-form-label">
                    <label class="required fw-bolder fs-6">Descuento Premium</label>
                  </div>
                  <div class="col-xxl-12">
                    <input
                      v-model="mFormulario.descuentoPremium"
                      type="number"
                      step="1"
                      min="0"
                      max="100"
                      class="form-control"
                      placeholder=""
                    >
                  </div>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-xxl-12 col-form-label">
                <label class="required fw-bolder fs-6">Imagen
                  <i
                    class="fas fa-exclamation-circle ms-2 fs-7"
                    data-bs-toggle="tooltip"
                    title="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                    data-bs-original-title="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                    aria-label="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                  />
                </label>
              </div>
              <div class="col-xxl-12">
                <div
                  id="modal_producto_editar_ktinputimagen"
                  class="image-input  image-input-empty"
                  :style="'background-image: url('+mFormulario.urlFoto+')'"
                >
                  <div class="image-input-wrapper w-125px h-125px" />
                  <label
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="change"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Cambiar imagen"
                  >
                    <i class="bi bi-pencil-fill fs-7" />
                    <input
                      type="file"
                      name="avatar"
                      accept=".png, .jpg, .jpeg"
                    >
                    <input
                      type="hidden"
                      name="avatar_remove"
                    >
                  </label>
                  <span
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="cancel"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Cancelar imagen"
                  >
                    <i class="bi bi-x fs-2" />
                  </span>
                  <span
                    id="modal_producto_editar_ktinputimagen_eliminar"
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="remove"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Eliminar imagen"
                  >
                    <i class="bi bi-x fs-2" />
                  </span>
                </div>
              </div>
            </div>

            <div class="row mb-2">
              <div class="col-xxl-12">
                <label class="required fw-bolder fs-6">Descripción</label>
              </div>
              <div class="col-xxl-12">
                <editor
                  id="uuid2"
                  v-model="mFormulario.descripcion"
                  api-key="1xeptavkfan6chg28kymlf0z72m52jfulcbiku9gi7jwvo8d"
                  cloud-channel="6"
                  :disabled="false"
                  initial-value=""
                  model-events=""
                  plugins=""
                  tag-name="div"
                  toolbar=""
                />
              </div>
            </div>
          </div>

          <div class="modal-footer px-10 py-5">
            <button
              type="button"
              class="btn btn-secondary"
              data-bs-dismiss="modal"
              @click="onCerrarModal()"
            >
              Cancelar
            </button>
            <button
              id="modal_producto_editar_btn_guardar"
              type="button"
              class="btn btn-primary"
              @click="onProductoModificar()"
            >
              <span class="indicator-label">Guardar</span>
              <span class="indicator-progress">
                Espere por favor... <span class="spinner-border spinner-border-sm align-middle ms-2" />
              </span>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import InputImagen from "@/core/util/InputImagen";
import BloqueoUI from "@/core/util/BloqueoUI";
import Editor from '@tinymce/tinymce-vue';
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import Alerta from "@/core/util/Alerta";

export default {
  name: 'ModalProductoEditar',
  components: {
    Editor
  },
  props: {
    producto: { type: Object, required: true, default() {
        return {
          id: {type: Number, required: true},
        }
      }
    }
  },
  emits: ['onProductoListar'],
  data() {
    return {
      componentes: {
        inputImagen: null,
        bloqueoUI: null,
      },
      mFormulario: {
        nombre: '', descripcion: '', precio: '', tipoMoneda: 'BOB',
        descuentoGratuito: '', descuentoPremium: '', tipoUnidad: '', urlFoto: ''
      }
    };
  },

  watch: {
    producto: function() {
      this.onProductoEditar();
    }
  },

  mounted() {
    this.componentes.inputImagen = new InputImagen('#modal_producto_editar_ktinputimagen');
    this.componentes.bloqueoUI = new BloqueoUI('#modal_producto_editar_formulario', '#modal_producto_editar_btn_guardar');
  },
  methods: {
    onProductoEditar() {
      Servicio.get(Ruta.rutaPanelProductoMostrar(this.$route.params.id, this.producto.id)).then( (data) => {
        this.mFormulario = data.data;
      }).catch( (error) => {
        this.response.mostrar = 'ERROR';
        Toast.mostrarError(error);
      });
    },

    onProductoModificar() {
      this.mFormulario.foto = this.componentes.inputImagen.imagen;
      this.componentes.bloqueoUI.iniciarBloqueoFormulario();

      Servicio.postMultiPart(Ruta.rutaPanelProductoModificar(this.$route.params.id, this.producto.id), this.mFormulario).then( (data) => {
        Toast.mostrarExito(data.mensaje);
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        this.$emit('onProductoListar');
        this.cerrarModal();
      }).catch((error) => {
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Alerta.alertaError(error);
      });
    },

    onCerrarModal() {
      this.mFormulario = {
        nombre: '', descripcion: '', precio: '', tipoMoneda: 'BOB',
        descuentoGratuito: '', descuentoPremium: '', urlFoto: '', tipoUnidad: ''
      };
      this.componentes.inputImagen.limpiar();
    },

    cerrarModal() {
      document.querySelector('#modal_producto_editar_btn_cerrar').click();
    }
  }
}
</script>